# Copyright (c) 2000-2012, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define section free
%define _binary_payload w9.gzdio
%define _source_payload w9.gzdio
%define _binary_filedigest_algorithm 1
%define _source_filedigest_algorithm 1

Name:           aether
Summary:        Aether Repository API
Url:            http://www.sonatype.org/aether/
Version:        1.13.1
Release:        2%{?dist}
Epoch:          0
License:        EPL
Group:          Development/Libraries
Source0:        sonatype-aether-1.13.1.tar.gz
# git clone git://github.com/sonatype/sonatype-aether.git^C
# cd sonatype-aether/
# git tag -l
# git archive aether-1.13.1 > ../SOURCES/sonatype-aether-1.13.1.tar
# gzip ../SOURCES/sonatype-aether-1.13.1.tar
 
Source1:        %{name}-settings.xml
Source2:        %{name}-jpp-depmap.xml
Source3:        http://repo1.maven.org/maven2/com/intellij/annotations/9.0.4/annotations-9.0.4.jar
Source4:        http://repo1.maven.org/maven2/com/intellij/annotations/9.0.4/annotations-9.0.4.pom

Patch0:         aether-pom.patch
Patch1:         aether-impl-pom.patch
Patch2:         aether-connector-file-pom.patch
Patch3:         aether-connector-wagon-pom.patch
Patch4:         aether-connector-asynchttpclient-pom.patch

BuildRequires:  jpackage-utils >= 0:1.7.5
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  ant >= 0:1.7.1
BuildRequires:  maven2 >= 0:2.0.8
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-idea
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-plugin
BuildRequires:  maven2-plugin-release
BuildRequires:  maven2-plugin-remote-resources
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-source
BuildRequires:  maven-surefire-plugin
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  maven-wagon
BuildRequires:  mojo-clirr-maven-plugin
BuildRequires:  mojo-signatures
BuildRequires:  animal-sniffer
BuildRequires:  apache-commons-parent
BuildRequires:  apache-felix-maven-bundle-plugin
BuildRequires:  apache-jar-resource-bundle
BuildRequires:  async-http-client
BuildRequires:  easymock2
BuildRequires:  google-pom
BuildRequires:  gossip >= 0:1.8
BuildRequires:  jetty6
BuildRequires:  junit4
BuildRequires:  oss-parent
BuildRequires:  plexus-classworlds
BuildRequires:  plexus-containers-component-annotations
BuildRequires:  plexus-containers-component-metadata
BuildRequires:  plexus-utils
BuildRequires:  sisu
BuildRequires:  sisu-goodies
BuildRequires:  slf4j
BuildRequires:  sonatype-http-testing-harness

Requires(post):    jpackage-utils >= 0:1.7.5
Requires(postun):  jpackage-utils >= 0:1.7.5
Requires:  java >= 0:1.6.0
Requires:  maven-wagon
Requires:  async-http-client
Requires:  gossip >= 0:1.8
Requires:  plexus-classworlds
Requires:  plexus-containers-component-annotations
Requires:  plexus-containers-component-metadata
Requires:  plexus-utils
Requires:  sisu
Requires:  slf4j
Requires:  ops4j-pax-swissbox

BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-buildroot

%description
This library provides a foundation of standards and best 
practices for tools and systems that need to interact with
software artifact libraries.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%prep
%setup -q -c
chmod -R go=u-w *
for f in $(find . -name "*.jar"); do
  mv $f $f.no
done
cp %{SOURCE1} settings.xml
%patch0 -b .sav0
%patch1 -b .sav1
%patch2 -b .sav2
%patch3 -b .sav3
%patch4 -b .sav4
rm aether-connector-wagon/src/test/java/org/sonatype/aether/connector/wagon/TestSuiteHttpWagon.java

%build
sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/.m2/repository</url>|g" settings.xml

export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
mkdir -p $MAVEN_REPO_LOCAL/com/intellij/annotations/9.0.4/
cp %{SOURCE3} $MAVEN_REPO_LOCAL/com/intellij/annotations/9.0.4/annotations-9.0.4.jar
cp %{SOURCE4} $MAVEN_REPO_LOCAL/com/intellij/annotations/9.0.4/annotations-9.0.4.pom

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

export SETTINGS=$(pwd)/settings.xml

mvn-jpp \
        -e \
        -s $SETTINGS \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven.test.failure.ignore=true \
        install 
pushd aether-impl
export CLASSPATH=$(build-classpath plexus/containers-container-default plexus/containers-component-metadata plexus/containers-component-annotations plexus/cli plexus/classworlds plexus/util commons-cli google-collections xbean/xbean-reflect jdom maven2/plugin-api qdox objectweb-asm/asm-all):target/classes:../aether-spi/target/aether-spi-1.13.1.jar:../aether-api/target/aether-api-1.13.1.jar
java org.codehaus.plexus.metadata.PlexusMetadataGeneratorCli -X -o target/classes/META-INF/plexus/components.xml -s src/main/java/ -c target/classes/ -m src/main/resources
mvn-jpp \
        -e \
        -s $SETTINGS \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven.test.failure.ignore=true \
        install 
popd
pushd aether-connector-file
export CLASSPATH=$(build-classpath plexus/containers-container-default plexus/containers-component-metadata plexus/containers-component-annotations plexus/cli plexus/classworlds plexus/util commons-cli google-collections xbean/xbean-reflect jdom maven2/plugin-api qdox objectweb-asm/asm-all):target/classes:../aether-spi/target/aether-spi-1.13.1.jar:../aether-api/target/aether-api-1.13.1.jar
java org.codehaus.plexus.metadata.PlexusMetadataGeneratorCli -X -o target/classes/META-INF/plexus/components.xml -s src/main/java/ -c target/classes/ -m src/main/resources
mvn-jpp \
        -e \
        -s $SETTINGS \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven.test.failure.ignore=true \
        install 
popd
pushd aether-connector-wagon
export CLASSPATH=$(build-classpath plexus/containers-container-default plexus/containers-component-metadata plexus/containers-component-annotations plexus/cli plexus/classworlds plexus/util commons-cli google-collections xbean/xbean-reflect jdom maven2/plugin-api qdox objectweb-asm/asm-all):target/classes:../aether-spi/target/aether-spi-1.13.1.jar:../aether-api/target/aether-api-1.13.1.jar
java org.codehaus.plexus.metadata.PlexusMetadataGeneratorCli -X -o target/classes/META-INF/plexus/components.xml -s src/main/java/ -c target/classes/ -m src/main/resources
mvn-jpp \
        -e \
        -s $SETTINGS \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven.test.failure.ignore=true \
        install 
popd
mvn-jpp \
        -e \
        -s $SETTINGS \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        javadoc:aggregate

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms

%add_to_maven_depmap org.sonatype.aether aether %{version} JPP/%{name} aether
install -m 644 pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-aether.pom

%add_to_maven_depmap org.sonatype.aether aether-api %{version} JPP/%{name} aether-api
install -m 644 aether-api/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-aether-api.pom
install -m 644 aether-api/target/aether-api-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/aether-api-%{version}.jar

%add_to_maven_depmap org.sonatype.aether aether-connector-asynchttpclient %{version} JPP/%{name} aether-connector-asynchttpclient
install -m 644 aether-connector-asynchttpclient/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-aether-connector-asynchttpclient.pom
install -m 644 aether-connector-asynchttpclient/target/aether-connector-asynchttpclient-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/aether-connector-asynchttpclient-%{version}.jar

%add_to_maven_depmap org.sonatype.aether aether-connector-file %{version} JPP/%{name} aether-connector-file
install -m 644 aether-connector-file/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-aether-connector-file.pom
install -m 644 aether-connector-file/target/aether-connector-file-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/aether-connector-file-%{version}.jar

%add_to_maven_depmap org.sonatype.aether aether-connector-wagon %{version} JPP/%{name} aether-connector-wagon
install -m 644 aether-connector-wagon/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-aether-connector-wagon.pom
install -m 644 aether-connector-wagon/target/aether-connector-wagon-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/aether-connector-wagon-%{version}.jar

%add_to_maven_depmap org.sonatype.aether aether-impl %{version} JPP/%{name} aether-impl
install -m 644 aether-impl/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-aether-impl.pom
install -m 644 aether-impl/target/aether-impl-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/aether-impl-%{version}.jar

%add_to_maven_depmap org.sonatype.aether aether-spi %{version} JPP/%{name} aether-spi
install -m 644 aether-spi/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-aether-spi.pom
install -m 644 aether-spi/target/aether-spi-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/aether-spi-%{version}.jar

%add_to_maven_depmap org.sonatype.aether aether-test-util %{version} JPP/%{name} aether-test-util
install -m 644 aether-test-util/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-aether-test-util.pom
install -m 644 aether-test-util/target/aether-test-util-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/aether-test-util-%{version}.jar

%add_to_maven_depmap org.sonatype.aether aether-util %{version} JPP/%{name} aether-util
install -m 644 aether-util/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP.%{name}-aether-util.pom
install -m 644 aether-util/target/aether-util-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/aether-util-%{version}.jar

(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(-,root,root)
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/*.jar
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*

%files javadoc
%defattr(-,root,root,-)
%doc %{_javadocdir}/*

%changelog
* Fri Jan 25 2013 Ralph Apel <r.apel at r-apel.de> 0:1.13.1-2
- Bump release to rebuild and reupload

* Sun Jul 08 2012 Ralph Apel <r.apel at r-apel.de> 0:1.13.1-1
- 1.13.1

* Wed Jul 20 2011 David Walluck <dwalluck@redhat.com> 0:1.11-5
- disable wagon due to plexus-container-default multiple versions issue

* Wed Jul 13 2011 David Walluck <dwalluck@redhat.com> 0:1.11-4
- release (based on Fedora 1.11-3)

